Bug 55205 - bash 2.04.21/2.05.8 env var incompatibility
bash 2.04.21/2.05.8 env var incompatibility
Product: Red Hat Linux
Classification: Retired
Component: bash (Show other bugs)
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Bernhard Rosenkraenzer
Depends On:
  Show dependency treegraph
Reported: 2001-10-26 22:24 EDT by Allen Akin
Modified: 2008-05-01 11:38 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2001-10-30 07:17:42 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Allen Akin 2001-10-26 22:24:29 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; m18) Gecko/20010110

Description of problem:
Create the following shell script:
    func() {
        echo $var
    var=xxx func
    var=yyy func

When run on bash 2.04.21, this produces



When run on bash 2.05.8, it produces


My understanding is that setting the value of a variable on the
command line is supposed to temporarily affect the environment
for that command only.  This would mean the 2.04 behavior is
correct, and the 2.05 behavior is wrong.  I see no mention of the
change in the bash FAQ or COMPAT file.

As a practical matter, this incompatibility between the two
versions caused an existing shell script to fail, so there's
an existence proof that the change in behavior matters to at
least one user. :-)

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
See Description field above.

Additional info:
Comment 1 Bernhard Rosenkraenzer 2001-10-30 07:17:37 EST
I'm not sure whether or not this change is intentional (might be, because a 
function is not actually a separate process).

I've sent a message to the base maintainer, waiting for reply.
Comment 2 Bernhard Rosenkraenzer 2001-10-30 09:15:40 EST
From: Chet Ramey <chet@nike.ins.cwru.edu>
Feature.  POSIX.2, section 3.9.5, says:

        When a function is executed, it shall have the syntax-error and
        variable-assignment properties described for special built-in
        utilities in the enumerated list at the beginning of 3.14.

Section 3.14 says, in part:

        Variable assignments specified with special built-in utilities
        shall remain in effect after the built-in completes...

Note that bash behaves this way only when in posix mode.


Comment 3 Allen Akin 2001-10-30 12:46:47 EST
Note that this was a real incompatibility that cost me an afternoon to track
down (after upgrading from RH7.1 to 7.2).  The shell script in my case was
invoked by /sbin/ifup-local.  Since the shell behaves differently in POSIX
mode, the circumstantial evidence points to some change in the way ifup-local
is invoked between 7.1 and 7.2 -- perhaps it's now posixly-correct when it wasn't
before.  It might be nice to understand what changed, so that no other breakage
occurs as a result of the same incompatibility...

Note You need to log in before you can comment on or make changes to this bug.